#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "hpu2image4xi5test.py">
#<abstract4xi abstract = "tests hpu2image4xi.py"/>
#<verify4xi verification = "11" target = "hpu2image4xi.py"/>
#<contextualize4xi context = "image2d4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['hpu2image4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from hpu2commandqueue4xi import HPU2CommandQueue4Xi
from hpu2commandqueue4xi import create2commandqueue4hpu 
from hpu2commandqueue4xi import flush2commandqueue4hpu
from hpu2commandqueue4xi import finish2commandqueue4hpu
from hpu2commandqueue4xi import get2commandqueueinfo4hpu
from hpu2commandqueue4xi import release2commandqueue4hpu
from hpu2commandqueue4xi import retain2commandqueue4hpu
from hpu2commandqueue4xi import set2commandqueue4hpu
from hpu2commandqueue4xi import trace2commandqueue4hpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from hpu2context4xi import HPU2Context4Xi 
from hpu2context4xi import create2context4hpu
from hpu2context4xi import get2context4hpu
from hpu2context4xi import release2context4hpu
from hpu2context4xi import retain2context4hpu
from hpu2context4xi import set2context4hpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from hpu2device4xi import HPU4Xi
from hpu2device4xi import init2hpu4xi 
from hpu2device4xi import set2hpu4xi
from hpu2device4xi import get2hpu4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from hpu2event4xi import HPU2Event4Xi
from hpu2event4xi import create2event4hpu
from hpu2event4xi import get2eventinfo4hpu
from hpu2event4xi import release2event4hpu
from hpu2event4xi import retain2event4hpu
from hpu2event4xi import set2eventcallback4hpu 
from hpu2event4xi import set2event4hpu
from hpu2event4xi import trace2event4hpu
from hpu2event4xi import wait2event4hpu

# -------------------------------------------------------------------------------------------------
# Image module                           
# -------------------------------------------------------------------------------------------------
from hpu2image4xi import HPU2Image4Xi
from hpu2image4xi import create2image4hpu
from hpu2image4xi import get2imageinfo4hpu
from hpu2image4xi import get2supportedimageformats4hpu
from hpu2image4xi import manoeuvre2copyimage4hpu
from hpu2image4xi import manoeuvre2copyimagetobuffer4hpu
from hpu2image4xi import manoeuvre2copybuffertoimage4hpu
from hpu2image4xi import manoeuvre2readimage4hpu
from hpu2image4xi import manoeuvre2writeimage4hpu
from hpu2image4xi import manoeuvre2mapimage4hpu
from hpu2image4xi import copy2image4hpu
from hpu2image4xi import copy2imagetobuffer4hpu
from hpu2image4xi import copy2buffertoimage4hpu
from hpu2image4xi import read2image4hpu
from hpu2image4xi import map2image4hpu
from hpu2image4xi import release2image4hpu
from hpu2image4xi import retain2image4hpu
from hpu2image4xi import set2imagecallback4hpu 
from hpu2image4xi import set2image4hpu
from hpu2image4xi import trace2image4hpu
from hpu2image4xi import wait2image4hpu
from hpu2image4xi import write2image4hpu

# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       # 
       'b': Pickle2b4Xi,
       # 
       'c': Pickle2c4Xi,
       # 
       'd': Pickle2d4Xi,
       # 
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'HPU2Image4Xi': 'NACK4TRACE',
         'create2image4hpu': 'NACK4TRACE',
         'get2supportedimageformats4hpu': 'NACK4TRACE',
         'read2image4hpu': 'NACK4TRACE',
         'write2image4hpu': 'NACK4TRACE',
         'copy2image4hpu': 'NACK4TRACE',
         'copy2imagetobuffer4hpu': 'NACK4TRACE',
         'copy2buffer2image4hpu': 'NACK4TRACE',
         'map2image4hpu': 'NACK4TRACE',        
         'get2imageinfo4hpu': 'NACK4TRACE',
         'retain2image4hpu': 'NACK4TRACE',
         'release2image4hpu': 'NACK4TRACE',
         'trace2image4hpu': 'NACK4TRACE',
         'set2imagecallback4hpu': 'NACK4TRACE',
         'set2image4hpu': 'NACK4TRACE',                  
         'wait2image4hpu': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace for image4hpu test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-hpu2image4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing 2D Image of HPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Image of HPU sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-hpu2image4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for 2D Image of HPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-hpu2image4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourhpuxi.org/sw4xi/python33/owl/multiprocessing4hpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourhpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for 2D Image of HPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of 2D Image of HPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hpu2image4xi5test" usage = "
#   tests image4hpu
#"> 

# -------------------------------------------------------------------------------------------------    
def hpu2image4xi5test():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST_RESOURCESHARER4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
    

        # ---------------------------------------------------------------------------------------------
        # START TESTING                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 1A/700) OF HPU2IMAGE4XI5TEST - STARTED ', time4xi()) 
        print('=' *33)   
        # 23:10:30 10/10/11 Pacific Daylight Time
                
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - CREATE 2D IMAGE WITH FUNCTION                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2A/700) OF HPU2IMAGE4XI5TEST - TRYING TO CREATE 2D IMAGE4HPU ', time4xi())      
        print('=' *33)        
        # 
        try:
            response4create2Dimage = create2image4hpu()                                                                 # NO PARAMETERS - THE SYSTEM CREATES   
            print('(Step 2B/700) OF HPU2IMAGE4XI5TEST - CREATED 2D IMAGE4HPU ', time4xi())
            keys2response = response4create2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4create2Dimage[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-14B-15B-16B-17B-17D-18B-18C-19A-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-34H-35H-36B-37B-38B-39B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4hpu', 'METHOD': 'create2buffer4hpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4hpu at 0x0000000004CAFF48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000425A450>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4hpu', 'METHOD': 'create2context4hpu'}, 'FUNCTION2CALLBACK': <function trace2context4hpu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}
                
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 
                #   'COUNT2REFERENCE': 0, 
                #   'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                #   'CLASS': 'create2commandqueue4hpu', 
                #   'METHOD': 'create2commandqueue4hpu'}, 
                #   'FUNCTION2CALLBACK': <function trace2commandqueue4hpu at 0x000000000316A8C8>, 
                #   'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 
                #   'INFO2PRIVATE': None, 
                #   'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004851748>, 
                #   'NACK2RETURN': ' ', 'CONTEXT': ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 
                #   'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                #   'CLASS': 'create2context4hpu', 'METHOD': 'create2context4hpu'}, 'FUNCTION2CALLBACK': <function trace2context4hpu at 0x000000000315A1C8>, 
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004821550>
                # ROWPITCH  :  800
                # WIDTH  :  800
        except:
            print('(Step 2Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO CREATE 2D IMAGE4HPU *** ', time4xi())
             
            
                         
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - GET SUPPORTED 2D IMAGE FORMATS WITH FUNCTION                
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3A1/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SUPPORTED IMAGE FORMATS FOR HPU ', time4xi())  
        print('=' *33)    
        try:
            imageformats2hpu = get2supportedimageformats4hpu()                                                                       
            print('(Step 3A2/700) OF HPU2IMAGE4XI5TEST - GOT SUPPORTED IMAGE FORMATS FOR HPU: ', imageformats2hpu) 
            # {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
        except:
            print('(Step 3Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SUPPORTED IMAGE FORMATS FOR HPU', time4xi())
          
                        
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - GET 2D IMAGE INFO WITH FUNCTION                
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3B1/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SOME 2D IMAGE INFO FOR HPU ', time4xi())     
        print('=' *33)    
        task4getinfo2image = {}
        task4getinfo2image ['DIMENSION'] = 2
        task4getinfo2image ['WIDTH'] = 0
        task4getinfo2image ['HEIGHT'] = 0    
        try:
            response4imageinfo2hpu = get2imageinfo4hpu(task4getinfo2image)                                                                      
            print('(Step 3B2/700) OF HPU2IMAGE4XI5TEST - GOT SOME 2D IMAGE INFO FOR HPU ', time4xi())  
            keys2response = response4imageinfo2hpu.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4imageinfo2hpu[key2response])
                # HEIGHT  :  800
                # WIDTH  :  800
        except:
            print('(Step 3Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SOME 2D IMAGE INFO FOR HPU', time4xi())
        
        print('=' *33)          
        print('(Step 3C1/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET ALL 2D IMAGE INFO FOR HPU ', time4xi())      
        print('=' *33)       
        try:
            task4getinfo2image = {}
            task4getinfo2image ['DIMENSION'] = 2 
            task4getinfo2image ['DOMAIN'] = 'ALL'    
            response4getinfo2Dimage = get2imageinfo4hpu(task4getinfo2image)                                                                      
                                                                       
            print('(Step 3C2/700) OF HPU2IMAGE4XI5TEST - GOT ALL 2D IMAGE INFO FOR HPU ', time4xi()) 
            keys2response = response4getinfo2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2Dimage[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-14B-15B-16B-17B-17D-18B-18C-19A-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-34H-35H-36B-37B-38B-39B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004821550>
                # ROWPITCH  :  800
                # WIDTH  :  800
        except:
            print('(Step 3Z3/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET ALL 2D IMAGE INFO FOR HPU ***', time4xi())
    
                
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - SET IMAGE WITH FUNCTION - ALL ATTRIBUTES                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET IMAGE WITH FUNCTION ', time4xi())    
        print('=' *33)
        
        # ---------------------------------------------------------------------------------------------
        # (1) GET PLATFORM IDs TO SET CONTEXT
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4B/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
        print('=' *33)    
        platform2xi = {}
        try:
            platform2xi = get2platformids4xi()
            print('(Step 4B/33) OF HPU2IMAGE4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
             
        except:
            print('(Step 4Z/33) OF HPU2IMAGE4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
    
        # ---------------------------------------------------------------------------------------------
        # (2) INITIALIZE DEVICE                       
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2A/33) OF HPU2IMAGE4XI5TEST - TRYING TO INITIALIZE DEVICE4HPU ', time4xi())   
        print('=' *33)        
        try:
            device2hpu = init2hpu4xi()                                                                                # NO PARAMETERS - THE SYSTEM SHOULD INITIALIZE
            print('(Step 2B/33) OF HPU2IMAGE4XI5TEST - INITIALIZED DEVICE4HPU TO: ', device2hpu)        
            # {'RESOLUTION2TIMER4PROFILING': 318, 
            #   'ID2PLATFORM': '0000000001509568', 
            #   'PROFILING2QUEUE': 'ACK', 
            #   'EXECUTE2KERNELS4OPENCL': 'ACK', 
            #   'NATIVE2WIDTHLONG4VECTOR': 2 ...
            
        except:
            print('(Step 2Z/33) OF HPU2IMAGE4XI5TEST *** FAILED TO INITIALIZE DEVICE4HPU', time4xi())  
                
            
        # ---------------------------------------------------------------------------------------------
        # (3) CREATE CONTEXT                  
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3A/700) OF HPU2IMAGE4XI5TEST - TRYING TO CREATE CONTEXT4HPU ', time4xi())    
        print('=' *33)        
        try:
            context2hpu = create2context4hpu()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
            print('(Step 3B/700) OF HPU2IMAGE4XI5TEST - CREATED CONTEXT4HPU: ', context2hpu)                                  
            # {'COUNT2REFERENCE': 0,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
            
        except:
            print('(Step 3Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO CREATE CONTEXT4HPU', time4xi()) 
         
    
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4set2image = {}
    
        
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT - REQUIRED                           
        # ---------------------------------------------------------------------------------------------         
        task4set2image  ['CONTEXT'] = context2hpu  
     
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE - EXTRA                          
        # ---------------------------------------------------------------------------------------------         
        task4set2image  ['DEVICE'] = device2hpu  
    
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE PROPERTIES - NONE                           
        # ---------------------------------------------------------------------------------------------         
        task4set2image  ['PROPERTIES'] = None 
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) DEFINE ERROR CODE - REQUIRED                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image  ['CODE2ERROR'] = 0 
    
        
        # ---------------------------------------------------------------------------------------------
        # (9) SET QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image ['QUEUE'] = None
        print('(Step 9A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET QUEUE FOR IMAGE4HPU ', time4xi())   
        try:                               
            task4set2image ['QUEUE'] = Queue4Xi()                                                                                                                    
            print('(Step 9B/700) OF HPU2IMAGE4XI5TEST - QUEUE OF IMAGE4HPU: ', task4set2image ['QUEUE'])                           
            # <queue4xi.Queue4Xi object at 0x0000000004288B38> 
            
        except:
            print('(Step 9Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET QUEUE FOR IMAGE4HPU ', time4xi())  
                     
        
        # ---------------------------------------------------------------------------------------------
        # (10) SET PIPE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image ['PIPE'] = None
        print('(Step 10A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET PIPE FOR IMAGE4HPU ', time4xi())    
        try:                               
            task4set2image ['PIPE'] = Pipe4Xi()                                                                                                                    
            print('(Step 10B/700) OF HPU2IMAGE4XI5TEST - PIPE OF IMAGE4HPU: ', task4set2image ['PIPE'])                           
            # (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>) 
            
        except:
            print('(Step 10Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET PIPE FOR IMAGE4HPU ', time4xi())  
    
        
        # ---------------------------------------------------------------------------------------------
        # (11) SET COMMAND QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image ['COMMANDQUEUE'] = None
        print('(Step 11A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET COMMAND QUEUEFOR IMAGE4HPU ', time4xi())   
        try:                               
            task4set2image ['COMMANDQUEUE'] = create2commandqueue4hpu()                                                                                                                    
            print('(Step 11B/700) OF HPU2IMAGE4XI5TEST - COMMAND QUEUE OF IMAGE4HPU: ', task4set2image ['COMMANDQUEUE'])                           
            # {'CODE2ERROR': 0, 
            #   'COUNT2REFERENCE': 0, 
            #   'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}' ...
            
        except:
            print('(Step 11Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR IMAGE4HPU ', time4xi())  
                                                  
        
        # ---------------------------------------------------------------------------------------------
        # (11) SET 2D IMAGE - FINALLY!                           
        # ---------------------------------------------------------------------------------------------          
        response4set2Dimage = {} 
        print('(Step 11A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET 2D IMAGE4HPU ', time4xi())   
        try:                               
            response4set2Dimage = set2image4hpu(task4set2image)                                                                                                         
                                                                                          
            print('(Step 11B/700) OF HPU2IMAGE4XI5TEST - SET 2D IMAGE4HPU ', time4xi())
            keys2response = response4set2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4set2Dimage[key2response])
                # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4hpu', 'METHOD': 'create2buffer4hpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4hpu at 0x0000000004CAFF48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000425A450>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4hpu', 'METHOD': 'create2context4hpu'}, 'FUNCTION2CALLBACK': <function trace2context4hpu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-
                # PIPE  :  (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004288B38>
                # ROWPITCH  :  800
                # WIDTH  :  800
            
        except:
            print('(Step 11Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET 2D IMAGE4HPU *** ', time4xi())  
            
        
        # ---------------------------------------------------------------------------------------------
        # (12) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
    
        task4release2image  = {} 
        task4release2image  ['COUNT2REFERENCE'] = 1 
        response4release2image = {}
        
        print('(Step 12A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RELEASE 2D IMAGE OF HPU DEVICE ', time4xi())    
        # 
        try:                               
            response4release2Dimage = release2image4hpu(task4release2image)                                                                                             
            print('(Step 12B/700) OF HPU2IMAGE4XI5TEST - RELEASED 2D IMAGE OF HPU DEVICE ', time4xi())                           
            keys2response = response4release2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2Dimage[key2response])
                # { release2image4hpu : release2image4hpu ; (Step 8Z1/70) warning; count2reference-warning-by-release2image4hpu:  ** 0 ** ; time: 23:10:30 10/10/11 Pacific Daylight Time}
                # { release2image4hpu : release2image4hpu ; (Step 70/70) returning; hpu2image4xi-returning-by-release2image4hpu: {'CODE2ERROR': 0, 'ACK2RETURN': ' ', 'ROWPITCH': 800, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}, 'WIDTH': 800, 'BUFFER': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4apu', 'METHOD': 'create2buffer4apu'}, 'FUNCTION2CALLBACK': <function trace2buffer4apu at 0x0000000004CAFF48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000425A450>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 'FUNCTION2CALLBACK': <function trace2image4apu at 0x00000000031B4948>, 'FORMAT': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, 'HEIGHT': 800, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004288B38>, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'DEPTH': 0, 'COUNT2REFERENCE': 0, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4apu', 'METHOD': 'create2commandqueue4apu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4apu at 0x000000000316A8C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000043E2A90>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 556>, <read-write PipeConnection, handle 560>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' 8Z1-', 'POINTER': <mmap.mmap object at 0x000000000425A348>, 'EVENT': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2event4apu', 'METHOD': 'create2event4apu'}, 'FUNCTION2CALLBACK': <function trace2event4apu at 0x000000000317CDC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004713710>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4apu', 'METHOD': 'create2commandqueue4apu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4apu at 0x000000000316A8C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000003D0C198>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000315A1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 488>, <read-write PipeConnection, handle 492>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 456>, <read-write PipeConnection, handle 460>)}, 'PIPE': (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>)}; time: 23:10:30 10/10/11 Pacific Daylight Time}
                # (Step 12B/700) OF HPU2IMAGE4XI5TEST - RELEASED 2D IMAGE OF HPU DEVICE  23:10:30 10/10/11 Pacific Daylight Time
                # ACK2RETURN  :   
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}',
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2context4hpu', 
                # COUNT2REFERENCE  :  0
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   8Z1-
                # PIPE  :  (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004288B38>
                # ROWPITCH  :  800
                # WIDTH  :  800
            
        except:
            print('(Step 12Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RELEASE IMAGE OF HPU DEVICE ', time4xi())  
        
        task4getinfo2image = {}
        task4getinfo2image ['HEIGHT'] = 0
        task4getinfo2image ['WIDTH']  = 0
        task4getinfo2image ['DEPTH']  = 0
        response4getinfo2image = {}
        print('(Step 12C/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2Dimage = get2imageinfo4hpu (task4getinfo2image)                                                                                             
            keys2response = response4getinfo2Dimage.keys()
            print('(Step 12D/700) OF HPU2IMAGE4XI5TEST - GOT SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())   
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2Dimage[key2response])
                # DEPTH  :  0
                # HEIGHT  :  800
                # WIDTH  :  800
        except:
            print('(Step 12Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())  
                                    
        
        # ---------------------------------------------------------------------------------------------
        # (13) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAINED BY INCREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4retain2image  = {}
        task4retain2image  ['DIMENSION'] = 2 
        task4retain2image  ['COUNT2REFERENCE'] = 1 
        response4retain2Dimage = {}
        print('(Step 13A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RETAIN 2D IMAGE OF HPU DEVICE ', time4xi())   
        try:                               
            response4retain2Dimage = retain2image4hpu(task4retain2image)                                                                                                 
            print('(Step 13B/700) OF HPU2IMAGE4XI5TEST - RESPONSE4RETAIN2DIMAGE : ', time4xi())                         
            keys2response = response4retain2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2Dimage[key2response])
                # ACK2RETURN  :   6C-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004288B38>
                # ROWPITCH  :  800
                # WIDTH  :  800
                
        except:
            print('(Step 13Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RETAIN 2D IMAGE OF HPU DEVICE ', time4xi()) 
        
               
    
        # ---------------------------------------------------------------------------------------------
        # (14) IMAGE CALLBACK            
        # ---------------------------------------------------------------------------------------------    
        
        print('(Step 14A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET 2D IMAGE CALLBACK OF HPU DEVICE ', time4xi())  
        try:                               
            response4setcallback2image = set2imagecallback4hpu()                                                                                                 
            print('(Step 14B/700) OF HPU2IMAGE4XI5TEST - SET 2D IMAGE CALLBACK OF HPU DEVICE TO: ', response4setcallback2image)   
            # <function trace2image4hpu at 0x00000000031B4948>
        except:
            print('(Step 14Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET 2D IMAGE CALLBACK OF HPU DEVICE ', time4xi())  
    
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: TRACE FUNCTION TESTS                    
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 15A/25) OF HPU2IMAGE4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
        print('=' *33)      
        trace2hpu = None
        try:
            trace2hpu = trace2image4hpu() 
            print('(Step 15B/25) OF HPU2IMAGE4XI5TEST - TRACE2HPU: ', trace2hpu)  
            # {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4hpu-failed {}; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'trace2image4hpu', 'METHOD': 'trace2image4hpu'}
    
        except:
            print('(Step 15Z1/25) OF HPU2IMAGE4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu)     
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: WAIT FUNCTION TESTS                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 16A/700) OF HPU2IMAGE4XI5TEST - TRYING TO WAIT 2D IMAGE FOR HPU ', time4xi())   
        print('=' *33)      
        try:
            response4wait2hpu = wait2image4hpu()
            keys2response = response4wait2hpu.keys()
            print('(Step 16B/700) OF HPU2IMAGE4XI5TEST - WAITED 2D IMAGE FOR HPU ', time4xi()) 
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4wait2hpu[key2response])
                # ACK2RETURN  :   6C-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EMPTY2QUEUE  :  True
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FULL2QUEUE  :  False
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 524>, <read-write PipeConnection, handle 528>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A348>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004288B38>
                # ROWPITCH  :  800
                # SIZE2QUEUE  :  2147483646
        except:
            print('(Step 16Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO WAIT 2D IMAGE FOR HPU: ', wait2hpu)            
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                      
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 16C/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4HPU ', time4xi())       
        print('=' *33)      
        #                         
        respon4read2image = {} 
        task4read2image = None
     
        try:                               
            response4read2image = read2image4hpu(task4read2image)                                                                                                          
            print('(Step 16D/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH READ2IMAGE4HPU : ', response4read2image)
            # option 1 (in use):
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000003F28B38>,
            #  'PUBLISHERCHANNEL': <read-write PipeConnection,handle 416>,
            #  'CONSUMERCHANNEL': <read-write PipeConnection, handle 412>}
             
            # option 2 (not used):
            # THREAD STARTED FOR COMMAND & CONTROL:
            # { DummyProcess4Xi : __init__ ; (Step 1/7a) started; init-of-DummyProcess4Xi-started: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7b) passed; group-passed-to-init-of-DummyProcess4Xi: None; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7c) passed; target-passed-to-init-of-DummyProcess4Xi: <function manoeuvre2readimage4hpu at 0x0000000003F01C48>; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7d) passed; name-passed-to-init-of-DummyProcess4Xi: None; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7e) passed; args-passed-to-init-of-DummyProcess4Xi: (<queue4xi.Queue4Xi object at 0x0000000003FB3208>, <read-write PipeConnection, handle 412>, <read-write PipeConnection, handle 416>); time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7f) passed; kwargs-passed-to-init-of-DummyProcess4Xi: {}; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 1/7g) borning; dummyprocess2xi-of-DummyProcess4Xi-borning: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 2/7b) performed; Thread-init-performed-by-init-of-DummyProcess4Xi: <function __init__ at 0x0000000002891348>; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 7/7g) shared; set-daemon-shared-by-dummyprocess2xi-of-DummyProcess4Xi: <function setDaemon at 0x0000000002891CC8>; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { DummyProcess4Xi : __init__ ; (Step 7/7h) returning; time: 04:49:42 09/28/11 Pacific Daylight Time}
            # { read2image4hpu : read2image4hpu ; (Step 69B/70) createddummy2image4hpu-created-by-read2image4hpu: <DummyProcess4Xi(Thread-1, initial)>; time: 04:49:42 09/28/11 Pacific Daylight Time}
            
            queue2read4hpu      = response4read2image['QUEUE']
            channel2readpublish4hpu = response4read2image['PUBLISHERCHANNEL']
            channel2readconsume4hpu = response4read2image['CONSUMERCHANNEL']
        except:
            print('(Step 16Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4HPU ', time4xi()) 
            
        # ----------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SET SIMULATION FOR MANOEUVRE2READIMAGE4HPU FUNCTION TO CALL IT DIRECTLY INSTEAD OF TRUSTING THREAD                     
        # ---------------------.....-------------------------------------------------------------------------------------------------------- 
        ack2simulate4hpu = True
        nack2simulate4hpu = False        
              
             
        # -----------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2READIMAGE4HPU TO RECEIVE                 
        # -------------------------.........-------------------------------------------------------------------------      
        print('(Step 17A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())     
        # 01:44:40 09/29/11 Pacific Daylight Time
        try:                               
            message2send4hpu = "<copy4xi>copy2read4hpu</copy4xi>"
            channel2readpublish4hpu = response4read2image['PUBLISHERCHANNEL']
            channel2readpublish4hpu.send(message2send4hpu)
            print("(Step 17B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2readpublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2read4hpu</copy4xi>
        except:
            print('(Step 17Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())                                                
      
        # ---------------------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE2READIMAGE4HPU THREAD - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # ---------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 18C/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4read = manoeuvre2readimage4hpu(queue2read4hpu, channel2readconsume4hpu, channel2readpublish4hpu)
                print("(Step 18D/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", manoeuvre2readimage4hpu)
                # 
            except:
                print("(Step 18Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 19A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())     
        #
        try:
            channel2readconsume4hpu = response4read2image['CONSUMERCHANNEL']                              
            message2receive4hpu = channel2readconsume4hpu.recv()
            print("(Step 19B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2readconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <roger4xi>roger2read4hpu</roger4xi>
        except:
            print('(Step 19Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH READ2IMAGE4HPU ', time4xi())          
    
             
        # ------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2READIMAGE4HPU TO RECEIVE                
        # ------------------------------------------------------------------------------------------------------------      
        print('(Step 20A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2read4hpu</ready4xi>"
            channel2readpublish4hpu = response4read2image['PUBLISHERCHANNEL']
            channel2readpublish4hpu.send(message2send4hpu)
            print("(Step 20B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2readpublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2read4hpu</ready4xi> 
        except:
            print('(Step 20Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())                                                
      
        # -------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE2READIMAGE4HPU THREAD - LET IT RECEIVE READY AND SEND READY                
        # -------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 21A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4read = manoeuvre2readimage4hpu(queue2read4hpu, channel2readconsume4hpu, channel2readpublish4hpu)
                print("(Step 21B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", manoeuvre2readimage4hpu)
                # 
            except:
                print("(Step 21Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 22A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH READ2IMAGE4HPU ', time4xi())     
        #
        try:
            channel2readconsume4hpu = response4read2image['CONSUMERCHANNEL']                              
            message2receive4hpu = channel2readconsume4hpu.recv()
            print("(Step 22B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2readconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2read4hpu</ready4xi> 
        except:
            print('(Step 22Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH READ2IMAGE4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - IMAGE HPUXI 
        # -----------------------------------------------------------------------------------------         
        print('(Step 23A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 23B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 23C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 23D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2image = 10
            file2image.seek(offset2image)
            print("(Step 23E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2image)
            file2image.close()
            print("(Step 23F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 23Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 24A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue2read4hpu.put(path2image)             
            print("(Step 24B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png  
        except:
            print("(Step 24Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
            # 
    
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE2READIMAGE4HPU THREAD - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # -------------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 25A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4read = manoeuvre2readimage4hpu(queue2read4hpu, channel2readconsume4hpu, channel2readpublish4hpu)
                print("(Step 25B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", manoeuvre2readimage4hpu)
                # <function manoeuvre2readimage4hpu at 0x0000000004E98EC8>
            except:
                print("(Step 25Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # ------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ------------------------------------------------------------------------------------------------------          
        print('(Step 26A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel2readconsume4hpu.recv()
            print("(Step 26D/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2readconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi>
        except:
            print('(Step 26Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # ----------------------------------------------------------------------------------------------------------------------
        # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE2READIMAGE4HPU THREAD - LET MANOEUVRE2READIMAGE4HPU TO GO TO STATE 0               
        # ----------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 27A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4read = manoeuvre2readimage4hpu(queue2read4hpu, channel2readconsume4hpu, channel2readpublish4hpu)
                print("(Step 27B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4read)
                # {'MESSAGE2SEND4HPU': '<default4xi>default2read4hpu</default4xi>',
                #  'ACK2INFO4HPU': False,
                #  'MESSAGE2GET4HPU': '<default4xi>default2read4hpu</default4xi>',
                #  'MESSAGE2RECEIVE4HPU': '<default4xi>default2read4hpu</default4xi>',
                #  'CODE2ACK4HPU': ' 0D-',
                #  'MESSAGE2PUT4HPU': '<default4xi>default2read4hpu</default4xi>',
                #  'CODE2NACK4HPU': ' ',
                #  'STATE2MANOEUVRE4HPU': 0}
    
            except:
                print("(Step 27Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread               
            
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                 
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 28A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4HPU ', time4xi())        
        print('=' *33)      
        #                         
        respon4write2image = {} 
        task4write2image = None                                                                                         # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
     
        try:                               
            response4write2image = write2image4hpu(task4write2image)                                                                                                          
            print('(Step 28B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH WRITE2IMAGE4HPU : ', response4write2image)
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x000000000490DB38>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 608>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 604>}
     
            queue2write4hpu      = response4write2image['QUEUE']
            channel2writepublish4hpu = response4write2image['PUBLISHERCHANNEL']
            channel2writeconsume4hpu = response4write2image['CONSUMERCHANNEL']
        except:
            print('(Step 28Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4HPU ', time4xi()) 
            
             
        # -------------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2WRITEIMAGE4HPU TO RECEIVE                 
        # -------------------------------------------------------------------------------------------------------------      
        print('(Step 29A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())     
        # 
        try:                               
            message2send4hpu = "<copy4xi>copy2write4hpu</copy4xi>"
            channel2writepublish4hpu = response4write2image['PUBLISHERCHANNEL']
            channel2writepublish4hpu.send(message2send4hpu)
            print("(Step 29B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2writepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2write4hpu</copy4xi>
        except:
            print('(Step 29Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())                                                
      
        # -----------------------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SIMULATE MANOEUVRE2WRITEIMAGE4HPU  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # -----------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 30A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4write = manoeuvre2writeimage4hpu(queue2write4hpu, channel2writeconsume4hpu, channel2writepublish4hpu)
                print("(Step 30B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", manoeuvre2writeimage4hpu)
                # <function manoeuvre2writeimage4hpu at 0x0000000004E98F48>
            except:
                print("(Step 30Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 31A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())     
        #
        try:
            channel2writeconsume4hpu = response4write2image['CONSUMERCHANNEL']                              
            message2receive4hpu = channel2writeconsume4hpu.recv()
            print("(Step 31B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2writeconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <roger4xi>roger2write4hpu</roger4xi>
        except:
            print('(Step 31Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH WRITE2IMAGE4HPU ', time4xi())          
    
             
        # ---------------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2WRITEIMAGE4HPU TO RECEIVE                
        # ---------------------------------------------------------------------------------------------------------------      
        print('(Step 32A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2write4hpu</ready4xi>"
            channel2writepublish4hpu = response4write2image['PUBLISHERCHANNEL']
            channel2writepublish4hpu.send(message2send4hpu)
            print("(Step 32B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2writepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2write4hpu</ready4xi> 
        except:
            print('(Step 32Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())                                                
      
        # ---------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SIMULATE MANOEUVRE2WRITEIMAGE4HPU  - LET IT RECEIVE READY AND SEND READY                
        # ---------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 33A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4write = manoeuvre2writeimage4hpu(queue2write4hpu, channel2writeconsume4hpu, channel2writepublish4hpu)
                print("(Step 33B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", manoeuvre2writeimage4hpu)
                # <function manoeuvre2writeimage4hpu at 0x0000000004E98F48> 
            except:
                print("(Step 33Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 34A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH WRITE2IMAGE4HPU ', time4xi())     
        #
        try:
            channel2writeconsume4hpu = response4write2image['CONSUMERCHANNEL']                              
            message2receive4hpu = channel2writeconsume4hpu.recv()
            print("(Step 34B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2writeconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2write4hpu</ready4xi>
        except:
            print('(Step 34Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH WRITE2IMAGE4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - IMAGE HPUXI 
        # -----------------------------------------------------------------------------------------         
        print('(Step 35A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 35B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 35C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 35D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2hpu = 10
            file2image.seek(offset2hpu)
            print("(Step 35E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2hpu)
            file2image.close()
            print("(Step 35F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 35Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 36A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue2write4hpu.put(path2image)             
            print("(Step 36B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 36Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
            # 
    
        
        # ---------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SIMULATE MANOEUVRE2WRITEIMAGE4HPU  - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # ---------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 37A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4write = manoeuvre2writeimage4hpu(queue2write4hpu, channel2writeconsume4hpu, channel2writepublish4hpu)
                print("(Step 37B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", manoeuvre2writeimage4hpu)
                # <function manoeuvre2writeimage4hpu at 0x0000000004E98F48>
            except:
                print("(Step 37Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # -----------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ------------------------------------------------------------------------------------------------------          
        print('(Step 38A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel2writeconsume4hpu.recv()
            print("(Step 38D/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2writeconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi> 
        except:
            print('(Step 38Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # -------------------------------------------------------------------------------------------------------------------
        # PHASE I: WRITE FUNCTION  TESTS - SIMULATE MANOEUVRE2WRITEIMAGE4HPU  - LET MANOEUVRE2WRITEIMAGE4HPU TO GO TO STATE 0               
        # -------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 39A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4write = manoeuvre2writeimage4hpu(queue2write4hpu, channel2writeconsume4hpu, channel2writepublish4hpu)
                print("(Step 39B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4write) 
                # {'MESSAGE2SEND4HPU': '<default4xi>default2write4hpu</default4xi>', 
                #  'ACK2INFO4HPU': False, 
                #  'MESSAGE2GET4HPU': '<default4xi>default2write4hpu</default4xi>', 
                #  'MESSAGE2RECEIVE4HPU': '<default4xi>default2write4hpu</default4xi>', 
                #  'CODE2ACK4HPU': ' 0D-', 
                #  'MESSAGE2PUT4HPU': '<default4xi>default2write4hpu</default4xi>', 
                #  'CODE2NACK4HPU': ' ', 
                #  'STATE2MANOEUVRE4HPU': 0}
    
            except:
                print("(Step 39Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2WRITEIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread  
            
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                      
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 40A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4HPU ', time4xi())          
        print('=' *33)      
        #                         
        response4copy2image = {} 
        task4copy2image = None                                                                                         # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
     
        try:                               
            response4copy2image = copy2image4hpu(task4copy2image)                                                                                                          
            print('(Step 40B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH COPY2IMAGE4HPU : ', response4copy2image)
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000003F6BA90>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 616>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 612>}
            
            queue2copy4hpu      = response4copy2image['QUEUE']
            channel2copypublish4hpu = response4copy2image['PUBLISHERCHANNEL']
            channel2copyconsume4hpu = response4copy2image['CONSUMERCHANNEL']
        except:
            print('(Step 40Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4HPU ', time4xi()) 
             
        # -----------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                 
        # -----------------------------------------------------------------------------------------------------------      
        print('(Step 41A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())      
        # 
        try:                               
            message2send4hpu = "<copy4xi>copy2copy4hpu</copy4xi>"
            channel2copypublish4hpu.send(message2send4hpu)
            print("(Step 41B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2copypublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2copy4hpu</copy4xi>
        except:
            print('(Step 41Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())   
      
        # ---------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # ---------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 42A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())   
            try:        
                response2manoeuvre4copy = manoeuvre2copyimage4hpu(queue2copy4hpu, channel2copyconsume4hpu, channel2copypublish4hpu)
                print("(Step 42B/700) OF HPU2IMAGE4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4HPU, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<roger4xi>roger2copy4hpu</roger4xi>', 'ACK2INFO4HPU': False, 'MESSAGE2GET4HPU': '<default4xi>default2copy4hpu</default4xi>', 
                #  'MESSAGE2RECEIVE4HPU': '<copy4xi>copy2copy4hpu</copy4xi>', 'CODE2ACK4HPU': ' 0D-1C-', 'MESSAGE2PUT4HPU': '<default4xi>default2copy4hpu</default4xi>', 'CODE2NACK4HPU': ' ', 'STATE2MANOEUVRE4HPU': 1}
    
            except:
                print("(Step 42Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 43A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())      
        #
        try:
            message2receive4hpu = channel2copyconsume4hpu.recv()
            print("(Step 43B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2copyconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <roger4xi>roger2copy4hpu</roger4xi>
        except:
            print('(Step 43Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2IMAGE4HPU ', time4xi())          
    
             
        # ------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                
        # ------------------------------------------------------------------------------------------------------------      
        print('(Step 44A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2copy4hpu</ready4xi>"
            channel2copypublish4hpu.send(message2send4hpu)
            print("(Step 44B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel2copypublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2copy4hpu</ready4xi>
        except:
            print('(Step 44Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())                                                
      
        # -------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT RECEIVE READY AND SEND READY                
        # -------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 45A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copyimage4hpu(queue2copy4hpu, channel2copyconsume4hpu, channel2copypublish4hpu)
                print("(Step 45B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48> 
            except:
                print("(Step 45Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 46A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2IMAGE4HPU ', time4xi())     
        #
        try:
            message2receive4hpu = channel2copyconsume4hpu.recv()
            print("(Step 46B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2copyconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2copy4hpu</ready4xi> 
        except:
            print('(Step 46Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2IMAGE4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - IMAGE HPUXI COPY OPERATIONS 
        # -----------------------------------------------------------------------------------------         
        print('(Step 47A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 47B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 47C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 47D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2hpu = 10
            file2image.seek(offset2hpu)
            print("(Step 47E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2hpu)
            file2image.close()
            print("(Step 47F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
            
            
        except:
            print("(Step 47Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 48A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue2copy4hpu.put(path2image)             
            print("(Step 48B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 48Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
    
        
        # -------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # -------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 49A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4copy = manoeuvre2copyimage4hpu(queue2copy4hpu, channel2copyconsume4hpu, channel2copypublish4hpu)
                print("(Step 49B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48> 
            except:
                print("(Step 49Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # ----------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ----------------------------------------------------------------------------------------------------          
        print('(Step 50A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel2copyconsume4hpu.recv()
            print("(Step 50B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel2copyconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi>
        except:
            print('(Step 50Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # ----------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET MANOEUVRE2COPYIMAGE4HPU TO GO TO STATE 0               
        # ----------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 51A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copyimage4hpu(queue2copy4hpu, channel2copyconsume4hpu, channel2copypublish4hpu)
                print("(Step 51B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<default4xi>default2copy4hpu</default4xi>', 
                #  'ACK2INFO4HPU': False, 
                #  'MESSAGE2GET4HPU': '<default4xi>default2copy4hpu</default4xi>', 
                #  'MESSAGE2RECEIVE4HPU': '<default4xi>default2copy4hpu</default4xi>', 'CODE2ACK4HPU': ' 0D-', 'MESSAGE2PUT4HPU': '<default4xi>default2copy4hpu</default4xi>', 'CODE2NACK4HPU': ' ', 'STATE2MANOEUVRE4HPU': 0}
    
    
            except:
                print("(Step 51Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread  
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                      
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 60A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4HPU ', time4xi())            
        print('=' *33)      
        #                         
        response4copy2imagetobuffer = {} 
        task4copy2imagetobuffer = None                                                                                  # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
     
        try:                               
            response4copy2imagetobuffer = copy2imagetobuffer4hpu(task4copy2imagetobuffer)                                                                                                          
            print('(Step 60B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4HPU : ', response4copy2imagetobuffer)
            #  {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004023D68>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 668>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 664>}
            
            queue4copy2imagetobuffer4hpu      = response4copy2imagetobuffer['QUEUE']
            channel4copy2imagetobufferpublish4hpu = response4copy2imagetobuffer['PUBLISHERCHANNEL']
            channel4copy2imagetobufferconsume4hpu = response4copy2imagetobuffer['CONSUMERCHANNEL']
        except:
            print('(Step 60Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4HPU ', time4xi()) 
             
        # -----------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                 
        # -----------------------------------------------------------------------------------------------------------      
        print('(Step 61A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())      
        # 
        try:                               
            message2send4hpu = "<copy4xi>copy2copyimagetobuffer4hpu</copy4xi>"
            channel4copy2imagetobufferpublish4hpu.send(message2send4hpu)
            print("(Step 61B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4copy2imagetobufferpublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2copyimagetobuffer4hpu</copy4xi> 
        except:
            print('(Step 61Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())   
      
        # ---------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # ---------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 62A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())   
            try:        
                response2manoeuvre4copy = manoeuvre2copyimagetobuffer4hpu(queue4copy2imagetobuffer4hpu, channel4copy2imagetobufferconsume4hpu, channel4copy2imagetobufferpublish4hpu)
                print("(Step 62B/700) OF HPU2IMAGE4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4HPU, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
                # { 'MESSAGE2SEND4HPU': '<roger4xi>roger2copyimagetobuffer4hpu</roger4xi>',
                #   'ACK2INFO4HPU': False,
                #   'MESSAGE2GET4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'MESSAGE2RECEIVE4HPU': '<copy4xi>copy2copyimagetobuffer4hpu</copy4xi>',
                #   'CODE2ACK4HPU': ' 0D-1C-',
                #   'MESSAGE2PUT4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'CODE2NACK4HPU': ' ',
                #   'STATE2MANOEUVRE4HPU': 1}
    
            except:
                print("(Step 62Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 63A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())      
        #
        try:
            message2receive4hpu = channel4copy2imagetobufferconsume4hpu.recv()
            print("(Step 63B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copy2imagetobufferconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <read-write PipeConnection, handle 664>  CONTROL & COMMAND:  <roger4xi>roger2copyimagetobuffer4hpu</roger4xi> 
        except:
            print('(Step 63Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2IMAGETOBUFFER4HPU ', time4xi())          
    
             
        # ------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                
        # ------------------------------------------------------------------------------------------------------------      
        print('(Step 64A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2copyimagetobuffer4hpu</ready4xi>"
            channel4copy2imagetobufferpublish4hpu.send(message2send4hpu)
            print("(Step 64B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4copy2imagetobufferpublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2copyimagetobuffer4hpu</ready4xi> 
        except:
            print('(Step 64Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())                                                
      
        # -------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT RECEIVE READY AND SEND READY                
        # -------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 65A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copyimagetobuffer4hpu(queue4copy2imagetobuffer4hpu, channel4copy2imagetobufferconsume4hpu, channel4copy2imagetobufferpublish4hpu)
                print("(Step 65B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48> 
            except:
                print("(Step 65Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 66A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2IMAGETOBUFFER4HPU ', time4xi())     
        #
        try:
            message2receive4hpu = channel4copy2imagetobufferconsume4hpu.recv()
            print("(Step 66B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copy2imagetobufferconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2copyimagetobuffer4hpu</ready4xi>
        except:
            print('(Step 66Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2IMAGETOBUFFER4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - IMAGE HPUXI COPY OPERATIONS 
        # -----------------------------------------------------------------------------------------         
        print('(Step 67A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 67B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 67C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 67D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2hpu = 10
            file2image.seek(offset2hpu)
            print("(Step 67E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2hpu)
            file2image.close()
            print("(Step 67F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
            
            
        except:
            print("(Step 67Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 68A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue4copy2imagetobuffer4hpu.put(path2image)             
            print("(Step 68B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 68Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
    
        
        # -------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # -------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 69A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4copy = manoeuvre2copyimagetobuffer4hpu(queue4copy2imagetobuffer4hpu, channel4copy2imagetobufferconsume4hpu, channel4copy2imagetobufferpublish4hpu)
                print("(Step 69B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48>
            except:
                print("(Step 69Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # ----------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ----------------------------------------------------------------------------------------------------          
        print('(Step 70A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel4copy2imagetobufferconsume4hpu.recv()
            print("(Step 70B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copy2imagetobufferconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi>
        except:
            print('(Step 70Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # ----------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET MANOEUVRE2COPYIMAGE4HPU TO GO TO STATE 0               
        # ----------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 71A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copyimagetobuffer4hpu(queue4copy2imagetobuffer4hpu, channel4copy2imagetobufferconsume4hpu, channel4copy2imagetobufferpublish4hpu)
                print("(Step 71B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'ACK2INFO4HPU': False,
                #   'MESSAGE2GET4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'MESSAGE2RECEIVE4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'CODE2ACK4HPU': ' 0D-',
                #   'MESSAGE2PUT4HPU': '<default4xi>default2copyimagetobuffer4hpu</default4xi>',
                #   'CODE2NACK4HPU': ' ',
                #   'STATE2MANOEUVRE4HPU': 0}
    
            except:
                print("(Step 71Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread  
            
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                      
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 80A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())           
        print('=' *33)      
        #                         
        response4copybuffertoimage = {} 
        task4copybuffertoimage = None                                                                                  # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
     
        try:                               
            response4copybuffertoimage = copy2buffertoimage4hpu(task4copybuffertoimage)                                                                                                          
            print('(Step 80B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4HPU : ', response4copybuffertoimage)
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004250940>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 712>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 708>}
            
            queue4copybuffertoimage4hpu      = response4copybuffertoimage['QUEUE']
            channel4copybuffertoimagepublish4hpu = response4copybuffertoimage['PUBLISHERCHANNEL']
            channel4copybuffertoimageconsume4hpu = response4copybuffertoimage['CONSUMERCHANNEL']
        except:
            print('(Step 80Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4HPU ', time4xi()) 
             
        # -----------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                 
        # -----------------------------------------------------------------------------------------------------------      
        print('(Step 81A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())      
        # 
        try:                               
            message2send4hpu = "<copy4xi>copy2copybuffertoimage4hpu</copy4xi>"
            channel4copybuffertoimagepublish4hpu.send(message2send4hpu)
            print("(Step 81B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4copybuffertoimagepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2copybuffertoimage4hpu</copy4xi>
        except:
            print('(Step 81Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())   
      
        # ---------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # ---------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 82A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())   
            try:        
                response2manoeuvre4copy = manoeuvre2copybuffertoimage4hpu(queue4copybuffertoimage4hpu, channel4copybuffertoimageconsume4hpu, channel4copybuffertoimagepublish4hpu)
                print("(Step 82B/700) OF HPU2IMAGE4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4HPU, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<roger4xi>roger2copybuffertoimage4hpu</roger4xi>',
                #   'ACK2INFO4HPU': False,
                #   'MESSAGE2GET4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'MESSAGE2RECEIVE4HPU': '<copy4xi>copy2copybuffertoimage4hpu</copy4xi>',
                #   'CODE2ACK4HPU': ' 0D-1C-',
                #   'MESSAGE2PUT4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'CODE2NACK4HPU': ' ',
                #   'STATE2MANOEUVRE4HPU': 1}
    
                
            except:
                print("(Step 82Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 83A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())      
        #
        try:
            message2receive4hpu = channel4copybuffertoimageconsume4hpu.recv()
            print("(Step 83B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copybuffertoimageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <roger4xi>roger2copybuffertoimage4hpu</roger4xi>
        except:
            print('(Step 83Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())          
    
             
        # ------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                
        # ------------------------------------------------------------------------------------------------------------      
        print('(Step 84A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2copybuffertoimage4hpu</ready4xi>"
            channel4copybuffertoimagepublish4hpu.send(message2send4hpu)
            print("(Step 84B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4copybuffertoimagepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2copybuffertoimage4hpu</ready4xi>
        except:
            print('(Step 84Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())                                                
      
        # -------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT RECEIVE READY AND SEND READY                
        # -------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 85A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copybuffertoimage4hpu(queue4copybuffertoimage4hpu, channel4copybuffertoimageconsume4hpu, channel4copybuffertoimagepublish4hpu)
                print("(Step 85B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                #  <function manoeuvre2copyimage4hpu at 0x0000000004E98D48>
            except:
                print("(Step 85Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 86A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())     
        #
        try:
            message2receive4hpu = channel4copybuffertoimageconsume4hpu.recv()
            print("(Step 86B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copybuffertoimageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2copybuffertoimage4hpu</ready4xi>
        except:
            print('(Step 86Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH COPY2BUFFERTOIMAGE4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - IMAGE HPUXI COPY OPERATIONS 
        # -----------------------------------------------------------------------------------------         
        print('(Step 87A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 87B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 87C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 87D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2hpu = 10
            file2image.seek(offset2hpu)
            print("(Step 87E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2hpu)
            file2image.close()
            print("(Step 87F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
            
            
        except:
            print("(Step 87Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 88A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue4copybuffertoimage4hpu.put(path2image)             
            print("(Step 88B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 88Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
    
        
        # -------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # -------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 89A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4copy = manoeuvre2copybuffertoimage4hpu(queue4copybuffertoimage4hpu, channel4copybuffertoimageconsume4hpu, channel4copybuffertoimagepublish4hpu)
                print("(Step 89B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48> 
            except:
                print("(Step 89Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # ----------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ----------------------------------------------------------------------------------------------------          
        print('(Step 90A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel4copybuffertoimageconsume4hpu.recv()
            print("(Step 90B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4copybuffertoimageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi>
        except:
            print('(Step 90Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # ----------------------------------------------------------------------------------------------------------------
        # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET MANOEUVRE2COPYIMAGE4HPU TO GO TO STATE 0               
        # ----------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 91A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2copybuffertoimage4hpu(queue4copybuffertoimage4hpu, channel4copybuffertoimageconsume4hpu, channel4copybuffertoimagepublish4hpu)
                print("(Step 91B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'ACK2INFO4HPU': False,
                #   'MESSAGE2GET4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'MESSAGE2RECEIVE4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'CODE2ACK4HPU': ' 0D-',
                #   'MESSAGE2PUT4HPU': '<default4xi>default2copybuffertoimage4hpu</default4xi>',
                #   'CODE2NACK4HPU': ' ',
                #   'STATE2MANOEUVRE4HPU': 0}
    
                
            except:
                print("(Step 91Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread  
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND                      
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 92A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4HPU ', time4xi())           
        print('=' *33)      
        #                          
        response4map2image = {} 
        task4map2image = None                                                                                  # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
     
        try:                               
            response4map2image = map2image4hpu(task4map2image)                                                                                                          
            print('(Step 92B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL & COMMAND WITH MAP2IMAGE4HPU : ', response4map2image)
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004A2B438>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 752>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 748>}
                    
            queue4map2image4hpu      = response4map2image['QUEUE']
            channel4map2imagepublish4hpu = response4map2image['PUBLISHERCHANNEL']
            channel4map2imageconsume4hpu = response4map2image['CONSUMERCHANNEL']
        except:
            print('(Step 92Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4HPU ', time4xi()) 
             
        # -----------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SEND CONTROL & COMMAND COPY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                 
        # -----------------------------------------------------------------------------------------------------------      
        print('(Step 93A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())       
        # 
        try:                               
            message2send4hpu = "<copy4xi>copy2mapimage4hpu</copy4xi>"
            channel4map2imagepublish4hpu.send(message2send4hpu)
            print("(Step 93B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4map2imagepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <copy4xi>copy2mapimage4hpu</copy4xi>
        except:
            print('(Step 93Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())   
      
        # ---------------------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
        # ---------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 94A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())   
            try:        
                response2manoeuvre4copy = manoeuvre2mapimage4hpu(queue4map2image4hpu, channel4map2imageconsume4hpu, channel4map2imagepublish4hpu)
                print("(Step 94B/700) OF HPU2IMAGE4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4HPU, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<roger4xi>roger2mapimage4hpu</roger4xi>', 'ACK2INFO4HPU': False, 'MESSAGE2GET4HPU': '<default4xi>default2map4hpu</default4xi>', 'MESSAGE2RECEIVE4HPU': '<copy4xi>copy2mapimage4hpu</copy4xi>', 'CODE2ACK4HPU': ' 0D-1C-', 'MESSAGE2PUT4HPU': '<default4xi>default2map4hpu</default4xi>', 'CODE2NACK4HPU': ' ', 'STATE2MANOEUVRE4HPU': 1}
                
            except:
                print("(Step 94Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
    
        # ---------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND ROGER VIA PIPE                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 95A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())      
        #
        try:
            message2receive4hpu = channel4map2imageconsume4hpu.recv()
            print("(Step 95B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4map2imageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <roger4xi>roger2mapimage4hpu</roger4xi>
        except:
            print('(Step 95Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH MAP2IMAGE4HPU ', time4xi())          
    
             
        # ------------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SEND CONTROL & COMMAND READY VIA PIPE FOR MANOEUVRE2COPYIMAGE4HPU TO RECEIVE                
        # ------------------------------------------------------------------------------------------------------------      
        print('(Step 96A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SEND CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())     
        #
        try:                               
            message2send4hpu = "<ready4xi>ready2mapimage4hpu</ready4xi>"
            channel4map2imagepublish4hpu.send(message2send4hpu)
            print("(Step 96B/700) OF HPU2IMAGE4XI5TEST - SENT TO CHANNEL2PUBLISH4HPU: ", channel4map2imagepublish4hpu, " MESSAGE2SEND4HPU: " , message2send4hpu)                                                                                                
            # <ready4xi>ready2mapimage4hpu</ready4xi> 
        except:
            print('(Step 84Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SEND CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())                                                
      
        # -------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET IT RECEIVE READY AND SEND READY                
        # -------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 97A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2mapimage4hpu(queue4map2image4hpu, channel4map2imageconsume4hpu, channel4map2imagepublish4hpu)
                print("(Step 97B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48>
            except:
                print("(Step 97Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread    
                 
    
        # ---------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - RECEIVE CONTROL & COMMAND READY VIA PIPE                
        # ---------------------------------------------------------------------------------------          
        print('(Step 98A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND VIA PIPE WITH MAP2IMAGE4HPU ', time4xi())     
        #
        try:
            message2receive4hpu = channel4map2imageconsume4hpu.recv()
            print("(Step 98B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4map2imageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                  
            # <ready4xi>ready2mapimage4hpu</ready4xi> 
        except:
            print('(Step 86Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND VIA PIPE  WITH MAP2IMAGE4HPU ', time4xi())          
                              
        # -----------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - IMAGE HPUXI COPY OPERATIONS 
        # -----------------------------------------------------------------------------------------         
        print('(Step 99A/700) OF HPU2IMAGE4XI5TEST - TRYING FILE OPERATIONS WITH IMAGE HPUXI ', time4xi())       
        try:        
            path2image = '..//..//..//..//..//web//images//png//dragonxi.png'
            file2image = open(path2image)
            print("(Step 99B/700) OF HPU2IMAGE4XI5TEST - FILENO: ", file2image.fileno( ))  
            print("(Step 99C/700) OF HPU2IMAGE4XI5TEST - MODE: ", file2image.mode)
            print("(Step 99D/700) OF HPU2IMAGE4XI5TEST - NAME: ", file2image.name)
            offset2hpu = 10
            file2image.seek(offset2hpu)
            print("(Step 99E/700) OF HPU2IMAGE4XI5TEST - PERFORMED SEEK WITH OFFSET: ", offset2hpu)
            file2image.close()
            print("(Step 99F/700) OF HPU2IMAGE4XI5TEST - CLOSED IMAGE FILE: ", path2image)  
            # FILENO:  3
            # MODE:  r
            # NAME:  ..//..//..//..//..//web//images//png//dragonxi.png
            # PERFORMED SEEK WITH OFFSET:  10
            # CLOSED IMAGE FILE:  ..//..//..//..//..//web//images//png//dragonxi.png
            
            
        except:
            print("(Step 87Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM FILE OPERATIONS WITH IMAGE: ", path2image)        
            
             
        # -----------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - PUT IMAGE PATH TO QUEUE
        # -----------------------------------------------------------------------------------------                          
        print("(Step 100A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PUT IMAGE PATH TO QUEUE ", time4xi())      
        try:    
            queue4map2image4hpu.put(path2image)             
            print("(Step 100B/700) OF HPU2IMAGE4XI5TEST - PUT TO QUEUE IMAGE PATH: ", path2image) 
            # ..//..//..//..//..//web//images//png//dragonxi.png
        except:
            print("(Step 88Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PUT IMAGE PATH TO QUEUE ", time4xi()) 
    
        
        # -------------------------------------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - STATE III - GETS FROM QUEUE AND SENDS EITHER ACK OR NACK VIA PIPE               
        # -------------------------------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 101A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi()) 
            try:        
                response2manoeuvre4copy = manoeuvre2mapimage4hpu(queue4map2image4hpu, channel4map2imageconsume4hpu, channel4map2imagepublish4hpu)
                print("(Step 101B/700) OF HPU2IMAGE4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", manoeuvre2copyimage4hpu)
                # <function manoeuvre2copyimage4hpu at 0x0000000004E98D48>
            except:
                print("(Step 101Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread                     
                      
                                       
        # ----------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - RECEIVE ACK OR NACK ABOUT IMAGE OPERATION CONTROL & COMMAND VIA PIPE                
        # ----------------------------------------------------------------------------------------------------          
        print('(Step 102A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())      
        #
        try: 
            message2receive4hpu = channel4map2imageconsume4hpu.recv()
            print("(Step 102B/700) OF HPU2IMAGE4XI5TEST - RECEIVED FROM CHANNEL2CONSUME4HPU: ", channel4map2imageconsume4hpu, " CONTROL & COMMAND: ", message2receive4hpu)                                                                                                   
            # <ack4xi>ack2imageinfo4hpu</ack4xi>
        except:
            print('(Step 90Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RECEIVE CONTROL & COMMAND ABOUT IMAGE OPERTION VIA PIPE ', time4xi())               
     
        
        # ----------------------------------------------------------------------------------------------------------------
        # PHASE I: MAP2IMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4HPU  - LET MANOEUVRE2COPYIMAGE4HPU TO GO TO STATE 0               
        # ----------------------------------------------------------------------------------------------------------------       
        if ack2simulate4hpu is True:
            print("(Step 103A/700) OF HPU2IMAGE4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())  
            try:        
                response2manoeuvre4copy = manoeuvre2mapimage4hpu(queue4map2image4hpu, channel4map2imageconsume4hpu, channel4map2imagepublish4hpu)
                print("(Step 103B/700) OF HPU2IMAGE4XI5TEST - GOT RESPONSE2MANOEUVRE4HPU ", response2manoeuvre4copy)
                # {'MESSAGE2SEND4HPU': '<default4xi>default2map4hpu</default4xi>', 'ACK2INFO4HPU': False, 'MESSAGE2GET4HPU': '<default4xi>default2map4hpu</default4xi>', 'MESSAGE2RECEIVE4HPU': '<default4xi>default2map4hpu</default4xi>', 'CODE2ACK4HPU': ' 0D-', 'MESSAGE2PUT4HPU': '<default4xi>default2map4hpu</default4xi>', 'CODE2NACK4HPU': ' ', 'STATE2MANOEUVRE4HPU': 0}
                
            except:
                print("(Step 103Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4HPU ", time4xi())     
        else:
            pass # trust activated thread  
                                                                                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS                          
        # ---------------------------------------------------------------------------------------------
        print('=' *33)          
        print('(Step 105A/700) OF HPU2IMAGE4XI5TEST - CREATING IMAGE4HPU OBJECT ', time4xi())     
        print('=' *33)  
        # 
        try:
            # ---------------------------------------------------------------------------------------------
            # CREATE WITH OBJECT                        
            # ---------------------------------------------------------------------------------------------        
            imageobject2hpu = HPU2Image4Xi()
            print('(Step 105B/700) OF HPU2IMAGE4XI5TEST - CREATED IMAGE4HPU OBJECT: ', imageobject2hpu)                                  
            # <hpu2image4xi.HPU2Image4Xi object at 0x0000000003C39BE0>
            
        except:
            print('(Step 105Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO CREATE IMAGE4HPU OBJECT')
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - GET METHOD                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 106A1/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET 2D IMAGE INFO ', time4xi())    
        try:                               
            response4get2imageinfo = imageobject2hpu.get2imageinfo()                                 
            print('(Step 106A2/700) OF HPU2IMAGE4XI5TEST - GOT 2D IMAGE INFO ', time4xi())                                        
            keys2response = response4get2imageinfo.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4get2imageinfo[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-14B-15B-16B-17B-17D-18B-18C-19A-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-34H-35H-36B-37B-38B-39B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 02:00:44 10/06/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 02: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 02:00:43 10/06/11 Pacific Dayl ...
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 02:00:44 10/06/11 Pacific Daylight Time}', 'CLASS': 'create2image4hpu', 'METHOD': 'create2image4hpu'}
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 02:00:43 10/06/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x0000000004E93B48>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 828>, <read-write PipeConnection, handle 832>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x00000000043518C8>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003DF00B8>
                # ROWPITCH  :  800
                # WIDTH  :  800   
        except:
            print('(Step 106Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET 2D IMAGE INFO ', time4xi()) 
        
        task4getinfo2image = {}
        task4getinfo2image ['HEIGHT'] = 0
        task4getinfo2image ['WIDTH'] = 0
        response4getinfo2image = {}
        print('(Step 106A2/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())    
        # 
        try:                               
            response4getinfo2Dimage = imageobject2hpu.get2imageinfo(task4getinfo2image)                                                                                             
            keys2response = response4getinfo2Dimage.keys()
            print('(Step 106A3/700) OF HPU2IMAGE4XI5TEST - GOT SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())   
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2Dimage[key2response])
                # HEIGHT  :  800
                # WIDTH  :  800
        except:
            print('(Step 106Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi()) 
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - GET SUPPORTED 2D IMAGE FORMATS FOR HPU               
        # ---------------------------------------------------------------------------------------------        
        print('(Step 106B1/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SUPPORTED IMAGE FORMATS FOR HPU')
        try:
            cc2xi = HPU2Image4Xi()                            
            supportedimageformats2hpu = cc2xi.get2supportedimageformats()                                  
            print('(Step 106B2/33) OF HPU4XI5TEST - GOT SUPPORTED 2D IMAGE FORMATS FOR HPU: ', supportedimageformats2hpu)
            # {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}                                                  
        except:
            print('(Step 102Z/33) OF HPU4XI5TEST *** FAILED TO GET SUPPORTED 2D IMAGE FORMATS FOR HPU***')    
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET METHOD            
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 107A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET 2D IMAGE ', time4xi())
        print('=' *33)       
        # 
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4set2image = {}
    
    
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT - REQUIRED                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2image  ['CONTEXT'] = context2hpu  
    
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE - EXTRA                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2image  ['DEVICE'] = device2hpu  
                          
    
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE ERROR CODE - REQUIRED                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image  ['CODE2ERROR'] = 0 
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        print('(Step 108A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET QUEUE4XI ', time4xi()) 
        task4set2image  ['QUEUE'] = None
        try:
            task4set2image  ['QUEUE'] = Queue4Xi() 
            print('(Step 108B/700) OF HPU2IMAGE4XI5TEST - QUEUE : ', task4set2image  ['QUEUE']) 
            # <queue4xi.Queue4Xi object at 0x0000000003F99748>
            
        except:
            print('(Step 108Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO CREATE QUEUE4XI ', time4xi()) 
                
        # ---------------------------------------------------------------------------------------------
        # (9) PIPE                           
        # ---------------------------------------------------------------------------------------------         
        print('(Step 109A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET PIPE4XI ', time4xi()) 
        task4set2image  ['PIPE'] = None
        try:
            task4set2image  ['PIPE'] = Pipe4Xi() 
            print('(Step 109B/700) OF HPU2IMAGE4XI5TEST - PIPE : ', task4set2image  ['PIPE'])
            # (<read-write PipeConnection, handle 900>, <read-write PipeConnection, handle 904>)
            
        except:
            print('(Step 109Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET PIPE4XI ', time4xi()) 
        
        # ---------------------------------------------------------------------------------------------
        # (10) SET COMMAND QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2image ['COMMANDQUEUE'] = None
        print('(Step 110A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET COMMAND QUEUEFOR IMAGE4HPU ', time4xi())   
        try:                               
            task4set2image ['COMMANDQUEUE'] = create2commandqueue4hpu()                                                                                                                    
            print('(Step 110B/700) OF HPU2IMAGE4XI5TEST - COMMAND QUEUE OF IMAGE4HPU: ', task4set2image ['COMMANDQUEUE'])                           
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 02:00:44 10/06/11 Pa ...
                    
        except:
            print('(Step 110Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR IMAGE4HPU ', time4xi())  
                                                
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET IMAGE WITH METHOD                  
        # ---------------------------------------------------------------------------------------------     
        print('(Step 111A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET 2D IMAGE FOR HPU: ', time4xi())      
        try: 
            response4set2Dimage = imageobject2hpu.set2image(task4set2image)                                                       
            keys2response = response4set2Dimage.keys()
            print('(Step 111B/700) OF HPU2IMAGE4XI5TEST - SET 2D IMAGE FOR HPU: ', time4xi()) 
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4set2Dimage[key2response])
                # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-
                # PIPE  :  (<read-write PipeConnection, handle 868>, <read-write PipeConnection, handle 872>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A768>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003F92668>
                # ROWPITCH  :  800
                # WIDTH  :  800
            
        except:
            print('(Step 111Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET 2D IMAGE FOR HPU: ', time4xi()) 
            
    
                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RELEASE 2D IMAGE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 121A/700) OF HPU2IMAGE4XI5TEST - RELEASING 2D IMAGE', time4xi())  
        print('=' *33)      
        # 
        task4release2image  = {}
        task4release2image  ['COUNT2REFERENCE'] = 1
        try:
            response4release2Dimage = imageobject2hpu.release2image(task4release2image)
            keys2response = response4release2Dimage.keys()
            print('(Step 111B/700) OF HPU2IMAGE4XI5TEST - RELEASED 2D IMAGE', time4xi())  
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2Dimage[key2response])
                # ACK2RETURN  :   
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  0
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   8Z1-
                # PIPE  :  (<read-write PipeConnection, handle 868>, <read-write PipeConnection, handle 872>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A768>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003F92668>
                # ROWPITCH  :  800
                # WIDTH  :  800
        except:
            print('(Step 121Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RELEASE 2D IMAGE', time4xi())  
            
                                                                                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RETAIN IMAGE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 122A/700) OF HPU2IMAGE4XI5TEST - RETAINING 2D IMAGE ', time4xi())
        print('=' *33)      
        task4retain2image  = {}
        task4retain2image  ['COUNT2REFERENCE'] = 1
        try:
            response4retain2Dimage = imageobject2hpu.retain2image(task4retain2image)
            keys2response = response4retain2Dimage.keys()
            print('(Step 122B/700) OF HPU2IMAGE4XI5TEST - RETAINED 2D IMAGE ', time4xi())  
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2Dimage[key2response])
                # ACK2RETURN  :   6C-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 868>, <read-write PipeConnection, handle 872>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A768>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003F92668>
                # ROWPITCH  :  800
                # WIDTH  :  800
        except:
            print('(Step 122Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RETAIN 2D IMAGE ', time4xi())
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - CREATE AGAIN IMAGE OBJECT AND USE ITS CREATE METHOD                           
        # ---------------------------------------------------------------------------------------------        
        print('(Step 123A/700) OF HPU2IMAGE4XI5TEST - TRYING TO CREATE 2D IMAGE for HPU ', time4xi()) 
        # 
        try:
            xi2hpu = HPU2Image4Xi()                            
            response4create2Dimage = xi2hpu.create2image()                                  
            keys2response = response4create2Dimage.keys()
            print('(Step 122B/700) OF HPU2IMAGE4XI5TEST - CREATED 2D IMAGE ', time4xi())  
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4create2Dimage[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-14B-15B-16B-17B-17D-18B-18C-19A-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-34H-35H-36B-37B-38B-39B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 836>, <read-write PipeConnection, handle 816>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A710>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004D9FCF8>
                # ROWPITCH  :  800
                # WIDTH  :  800
        except:
            print('(Step 123Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO CREATE 2D IMAGE for HPU ', time4xi())             
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET IMAGE CALLBACK WITH METHOD                           
        # ---------------------------------------------------------------------------------------------        
        print('(Step 124A/700) OF HPU2IMAGE4XI5TEST - TRYING TO SET IMAGE CALLBACK WITH METHOD OF OBJECT XI2HPU: ', xi2hpu) 
        # 
        try:
                             
            callback2hpu = xi2hpu.set2imagecallback()                                  
            print('(Step 124B/700) OF HPU2IMAGE4XI5TEST - SET IMAGE WITH CALLBACK TO: ', callback2hpu)
            # <function trace2image4hpu at 0x0000000003784448> 
                              
        except:
            print('(Step 124Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SET IMAGE CALLBACK WITH METHOD ***', time4xi())                  
    
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - TRACE IMAGES                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 125A/25) OF HPU2IMAGE4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
        print('=' *33)      
        # 
        
        trace2hpu = None
        try:
            trace2hpu = xi2hpu.trace2image() 
        
            print('=' *33)          
            print('(Step 125B/25) OF HPU2IMAGE4XI5TEST - TRACE2HPU: ', trace2hpu)  
            # {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4hpu-failed {}; time: 07:04:23 09/02/11 Pacific Daylight Time}', 'CLASS': 'trace2image4hpu', 'METHOD': 'trace2image4hpu'}
    
            
            print('=' *33)
        except:
            print('(Step 125Z1/25) OF HPU2IMAGE4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu)     
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - WAIT IMAGES                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 126A/700) OF HPU2IMAGE4XI5TEST - TRYING TO WAIT 2D IMAGE OPERATION FOR HPU ', time4xi()) 
        print('=' *33)      
        wait2hpu = {}
        try:
            response4wait2Dimage = xi2hpu.wait2image()
            print('(Step 122B/700) OF HPU2IMAGE4XI5TEST - WAITED 2D IMAGE OPERATION FOR HPU ', time4xi()) 
            keys2response = response4wait2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4wait2Dimage[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-14B-15B-16B-17B-17D-18B-18C-19A-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-34H-35H-36B-37B-38B-39B-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 02:00:44 10/06/ ...
                # CALLBACK  :  <function trace2image4hpu at 0x0000000004E93B48>
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 02: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 02:00:43 10/06/11 Pacific Dayl ...
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 02:00:44 10/06/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EMPTY2QUEUE  :  True
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 02:00:43 10/06/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FULL2QUEUE  :  False
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x0000000004E93B48>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 868>, <read-write PipeConnection, handle 848>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x0000000004351920>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x00000000040B7DD8>
                # ROWPITCH  :  800
                # SIZE2QUEUE  :  2147483646
        except:
            print('(Step 126Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO 2D IMAGE OPERATION FOR HPU ', time4xi())         
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - READ IMAGE - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 127A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH READ IMAGE OBJECT ', time4xi()) 
        print('=' *33)      
        #  
        response4read2hpu = {}
        try:
            response4read2hpu = xi2hpu.read2image()
        
            print('=' *33)          
            print('(Step 127B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL AND COMMAND WITH RESPONSE4READ2HPU: ', response4read2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x000000000494BF60>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 760>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 756>}
    
            print('=' *33)
        except:
            print('(Step 127Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH READ - READ2HPU: ', wait2hpu)                
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - WRITE IMAGE - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 128A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH WRITE IMAGE OBJECT ', time4xi()) 
        print('=' *33)      
        # 
        response4write2hpu = {}
        try:
            response4write2hpu = xi2hpu.write2image()
        
            print('=' *33)          
            print('(Step 128B/700) OF HPU2IMAGE4XI5TEST -  ESTABLISHED CONTROL AND COMMAND WITH WRITE2HPU, RESPONSE4WRITE2HPU: ', response4write2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004FB7630>, 
            #  'PUBLISHERCHANNEL': <read-write PipeConnection, handle 792>, 
            #  'CONSUMERCHANNEL': <read-write PipeConnection, handle 788>}
            print('=' *33)
        except:
            print('(Step 128Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH WRITE - RESPONSE4WRITE2HPU: ', response4write2hpu)                                                                                                                                     
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - COPY IMAGE - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 129A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH COPY IMAGE OBJECT ', time4xi()) 
        print('=' *33)      
        # 
        response4copy2hpu = {}
        try:
            response4copy2hpu = xi2hpu.copy2image()
        
            print('=' *33)          
            print('(Step 129B/700) OF HPU2IMAGE4XI5TEST -  ESTABLISHED CONTROL AND COMMAND WITH COPY2HPU, RESPONSE4COPY2HPU: ', response4copy2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000052F7208>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 864>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 860>}
            print('=' *33)
        except:
            print('(Step 129Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH COPY - RESPONSE4COPY2HPU: ', response4copy2hpu)                                                                                                                                     
    
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - COPY IMAGE TO BUFFER - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 130A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH COPY IMAGE TO BUFFER ', time4xi()) 
        print('=' *33)      
        # 
        response4copyimagetobuffer2hpu = {}
        try:
            response4copyimagetobuffer2hpu = xi2hpu.copy2imagetobuffer()
        
            print('=' *33)          
            print('(Step 130B/700) OF HPU2IMAGE4XI5TEST -  ESTABLISHED CONTROL AND COMMAND WITH COPY IMAGE TO BUFFER, RESPONSE4COPY2HPU: ', response4copyimagetobuffer2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004E71DD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 992>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 988>}
    
            print('=' *33)
        except:
            print('(Step 130Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH COPY IMAGE TO BUFFER - RESPONSE4COPYIMAGETOBUFFER2HPU: ', response4copyimagetobuffer2hpu) 
             
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - COPY BUFFER TO IMAGE - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 131A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH COPY BUFFER TO IMAGE OBJECT ', time4xi())  
        print('=' *33)      
        # 
        response4copybuffertoimage2hpu = {}
        try:
            response4copybuffertoimage2hpu = xi2hpu.copy2buffertoimage()
        
            print('=' *33)          
            print('(Step 131B/700) OF HPU2IMAGE4XI5TEST -  ESTABLISHED CONTROL AND COMMAND WITH COPY BUFFER TO IMAGE, RESPONSE4COPYBUFFERTOIMAGE2HPU: ', response4copybuffertoimage2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004EAB978>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 1020>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 1016>}
    
            print('=' *33)
        except:
            print('(Step 131Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH COPY BUFFER TO IMAGE - RESPONSE4COPYBUFFERTOIMAGE2HPU: ', response4copybuffertoimage2hpu) 
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - MAP IMAGE - ESTABLISH CONTROL AND COMMAND ONLY                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 132A/700) OF HPU2IMAGE4XI5TEST - TRYING TO ESTABLISH CONTROL AND COMMAND WITH MAP IMAGE OBJECT ', time4xi()) 
        print('=' *33)      
        #  
        response4map2hpu = {}
        try:
            response4map2hpu = xi2hpu.map2image()
        
            print('=' *33)          
            print('(Step 132B/700) OF HPU2IMAGE4XI5TEST - ESTABLISHED CONTROL AND COMMAND WITH RESPONSE4MAP2HPU: ', response4map2hpu) 
            # {'QUEUE': <queue4xi.Queue4Xi object at 0x000000000513E860>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 1100>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 1096>}
            print('=' *33)
        except:
            print('(Step 132Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ESTABLISH CONTROL AND COMMAND WITH MAP - MAP2HPU: ', wait2hpu) 
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RELEASE 2D IMAGE BY DECREMENTING REFERENCE COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4release2image  = {} 
        task4release2image  ['COUNT2REFERENCE'] = 1 
        response4release2image = {}
       
        print('(Step 133A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RELEASE 2D IMAGE OF HPU DEVICE ', time4xi())    
        # 
        try:                               
            response4release2Dimage = xi2hpu.release2image(task4release2image)                                                                                             
            print('(Step 133B/700) OF HPU2IMAGE4XI5TEST - RELEASED 2D IMAGE OF HPU DEVICE ', time4xi())                           
            keys2response = response4release2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2Dimage[key2response])
                # ACK2RETURN  :   
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  0
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EMPTY2QUEUE  :  True
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FULL2QUEUE  :  False
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   8Z1-
                # PIPE  :  (<read-write PipeConnection, handle 836>, <read-write PipeConnection, handle 816>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A710>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004D9FCF8>
                # ROWPITCH  :  800
                # SIZE2QUEUE  :  2147483646
        except:
            print('(Step 133Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RELEASE IMAGE OF HPU DEVICE ', time4xi())  
        
        task4getinfo2image = {}
        task4getinfo2image ['COUNT2REFERENCE'] = 0
        response4getinfo2image = {}
        print('(Step 133C/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2Dimage = xi2hpu.get2imageinfo (task4getinfo2image)                                                                                             
            keys2response = response4getinfo2Dimage.keys()
            print('(Step 133D/700) OF HPU2IMAGE4XI5TEST - GOT SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())   
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2Dimage[key2response])
                # COUNT2REFERENCE  :  0
        except:
            print('(Step 133Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())  
                                    
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RETAIN 2D IMAGE BY DECREASING REFERENCE WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4retain2image  = {}
        task4retain2image  ['COUNT2REFERENCE'] = 1 
        response4retain2Dimage = {}
        print('(Step 134A/700) OF HPU2IMAGE4XI5TEST - TRYING TO RETAIN 2D IMAGE OF HPU DEVICE ', time4xi())   
        try:                               
            response4retain2Dimage = xi2hpu.retain2image(task4retain2image)                                                                                                 
            print('(Step 134B/700) OF HPU2IMAGE4XI5TEST - RESPONSE4RETAIN2DIMAGE : ', time4xi())                         
            keys2response = response4retain2Dimage.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2Dimage[key2response])
                # ACK2RETURN  :   6C-
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4hpu-failed ; time: 23:10:30 10/10/ ...
                # CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 23: ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 23:10:30 10/10/11 Pacific Dayl ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2image4hpu-failed ; time: 23:10:31 10/10/11 Pacific Daylight Time}', 'CLASS': 'create2image4 ...
                # DEPTH  :  0
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHL ...
                # EMPTY2QUEUE  :  True
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 23:10:30 10/10/11 Pacific Daylight Time ...
                # FLAGS  :  0
                # FORMAT  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
                # FULL2QUEUE  :  False
                # FUNCTION2CALLBACK  :  <function trace2image4hpu at 0x00000000031B4948>
                # HEIGHT  :  800
                # NACK2RETURN  :   
                # PIPE  :  (<read-write PipeConnection, handle 836>, <read-write PipeConnection, handle 816>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # POINTER  :  <mmap.mmap object at 0x000000000425A710>
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000004D9FCF8>
                # ROWPITCH  :  800
                # SIZE2QUEUE  :  2147483646
        except:
            print('(Step 134Z1/700) OF HPU2IMAGE4XI5TEST *** FAILED TO RETAIN 2D IMAGE OF HPU DEVICE ', time4xi())
        task4getinfo2image = {}
        task4getinfo2image ['COUNT2REFERENCE'] = 0
        response4getinfo2image = {}
        print('(Step 134C/700) OF HPU2IMAGE4XI5TEST - TRYING TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2Dimage = xi2hpu.get2imageinfo (task4getinfo2image)                                                                                             
            keys2response = response4getinfo2Dimage.keys()
            print('(Step 134D/700) OF HPU2IMAGE4XI5TEST - GOT SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())   
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2Dimage[key2response])
                # COUNT2REFERENCE  :  1
        except:
            print('(Step 134Z2/700) OF HPU2IMAGE4XI5TEST *** FAILED TO GET SELECTED 2D IMAGE INFO OF HPU DEVICE ', time4xi())         
                                                            
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SENSE IMAGE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 170A/700) OF HPU2IMAGE4XI5TEST - SENSING ', time4xi())  
        print('=' *33)      
        
        try:
            print(xi2hpu.sense())
        
            print('=' *33)          
            print('(Step 170B/700) OF HPU2IMAGE4XI5TEST - SENSED ', time4xi()) 
            # {'object': <hpu2image4xi.HPU2Image4Xi object at 0x0000000003DC1A58>, 'classvariable2hpu-of-HPU2Image4Xi': 4}
            
            print('=' *33)
        except:
            print('(Step 170Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO SENSE ', time4xi())          
            
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - REASON IMAGE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 171A/700) OF HPU2IMAGE4XI5TEST - REASONING ', time4xi())
        print('=' *33)       
        
        try:
            print(xi2hpu.reason())
        
            print('=' *33)          
            print('(Step 171B/700) OF HPU2IMAGE4XI5TEST - REASONED ', time4xi())
            # {'object-reason-object4xi': <hpu2image4xi.HPU2Image4Xi object at 0x0000000003DC1A58>, 'time-reason-of-HPU2Image4Xi': '07:04:23 09/02/11 Pacific Daylight Time'} 
            
            print('=' *33)       
        except:
            print('(Step 171Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO REASON ', time4xi())                                   
                 
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - ACE IMAGE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 172A/700) OF HPU2IMAGE4XI5TEST - ACING ', time4xi())   
        print('=' *33)       
        
        try:
            print(xi2hpu.ace())
        
            print('=' *33)          
            print('(Step 172B/700) OF HPU2IMAGE4XI5TEST - ACED ', time4xi())                                                 
            # {'cores-of-HPU2Image4Xi': 4, 'object8xi': <hpu2image4xi.HPU2Image4Xi object at 0x0000000003DC1A58>} 
            
            print('=' *33) 
        except:
            print('(Step 172Z/700) OF HPU2IMAGE4XI5TEST *** FAILED TO ACE ', time4xi())                                       
         
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 174/700) OF HPU2IMAGE4XI5TEST - DONE! ', time4xi())
        # 23:10:31 10/10/11 Pacific Daylight Time                          
        print('=' *33) 
    finally:
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for hpu2image4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
       
    print('=' *33)
    print("(Step 0A/700) OF HPU2IMAGE4XI5TEST - SENSING IT WITH YOURHPUXI!", time4xi())   
    # 23:10:30 10/10/11 Pacific Daylight Time
    print('=' *33)
        
    hpu2image4xi5test()  
    
    print('=' *33)
    print("(Step 0B/700) OF HPU2IMAGE4XI5TEST - SENSED IT WITH YOURHPUXI!", time4xi()) 
    # 23:10:34 10/10/11 Pacific Daylight Time
       
    print('=' *33) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# hpu2image4xi5test.txt
# sense-hpu2image4xi5test.xml
# reason-hpu2image4xi5test.xml
# ace-hpu2image4xi5test.xml
#" 
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of hpu2image4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
